c ------------------------------------BOF---------------------------------------

c     user amplitude subroutine
c
      subroutine vuamp(
c          passed in for information and state variables
     *     ampName, time, ampValueOld,  dt,  nSvars, svars, lFlagsInfo,
     *     nSensor, sensorValues, sensorNames, jSensorLookUpTable,
c          to be defined
     *     ampValueNew,
     *     lFlagsDefine,
     *     AmpDerivative, AmpSecDerivative, AmpIncIntegral)

      include 'vaba_param.inc'

c     svars - additional state variables, similar to (V)UEL
      dimension sensorValues(nSensor), svars(nSvars)
      character*80 sensorNames(nSensor)
      character*80 ampName

c     time indices
      parameter (iStepTime        = 1,
     *           iTotalTime       = 2,
     *           nTime            = 2)
c     flags passed in for information
      parameter (iInitialization   = 1,
     *           iRegularInc       = 2,
     *           nFlagsInfo        = 2)
c     optional flags to be defined
      parameter (iComputeDeriv     = 1,
     *           iComputeSecDeriv  = 2,
     *           iComputeInteg     = 3,
     *           iStopAnalysis     = 4,
     *           nFlagsDefine      = 4)
      dimension time(nTime), lFlagsInfo(nFlagsInfo),
     *          lFlagsDefine(nFlagsDefine)
      dimension jSensorLookUpTable(*)

c
c   /\
c   || subroutine declaration section NEVER change anything here
c   || just copy text from documentation / example

c-------------------------------------------------------------------------------

c   || user declaration section
c   || here you can declare variables, parameters, arrays which you need
c   \/

      character*256 jobOutDir, jobName, outputFile
      integer*4     lenJobOutDir, lenJobName

c-------------------------------------------------------------------------------


c     do only for amplitude "SET_TORQUE_USER-AMP"
      if (ampName .eq. 'SET_TORQUE_USER-AMP') then

c       ------------------------------------------------------------------------
c       read sensor value (rot. velocity) and assign to variable
        rSensorRotVel = vGetSensorValue('SENSOR_ROT_VEL',
     &                  jSensorLookUpTable, sensorValues)
c       ------------------------------------------------------------------------

c       is it initial increament ? ...
        if (lFlagsInfo(iInitialization) .eq. 1) then

c         ... if true set initial values (ampValueNew, svars, ...)
          ampValueNew = 0.0d0

c         ----------------------------------------------------------------------
c         following lines are used two save ampValue to external file
c         to check dose it work fine or not

          if (.TRUE.) then

c           what name abaqus analysis has ?
            call vgetjobname(jobName, lenJobName)
c           where abaqus analysis is ?
            call vgetoutdir(jobOutDir, lenJobOutDir)

c           create output file to save all information
c           new file will be create in the same directory as abaqus analysis
c           with name abq_analysis_name + user amp. name + .out extension
            outputFile = jobOutDir(1:lenJobOutDir) //'/'//
     &        jobName(1:lenJobName)//'_'//trim(ampName)//'.out'

c           please refer to abq. doc. which file units you MUST NOT use
c           Abaqus Analysis User Manual -> 3.7 FORTRAN unit numbers
            open(unit=105, file=outputFile, status='UNKNOWN')

c           write header into the file
            write(105,'(:,10A16)') 'time','rotVel', 'ampValue'

          end if
c         ----------------------------------------------------------------------

        else

c         ----------------------------------------------------------------------
c         following lines is main body of a subroutine to set amplitude
c         value for each increament of calculation
c         !!! ampValueNew variable MUST BE set always for each inc
c         !!! if you do not set the variable it does not mean the
c         !!! amplitude value will be set to 0.0 or value from previous inc.
c         !!! in this case amplitude value will be set to UNKNOWN value

c         ... if false -> it is normal abaqus inc. during calculation

c         ... check rot. velocity condition
          if (rSensorRotVel .lt. 10.0d0) then
c           ... if rot. vel. is lower then 10.0d0 set amp. to zero
            ampValueNew = 0.0d0
          else
c           ... if rot. vel. is higher or equal set amp. to torque
            ampValueNew = 500.0d0
          end if
c         ----------------------------------------------------------------------

c         ----------------------------------------------------------------------
c         following lines are used two save ampValue to external file
c         to check dose it work fine or not

          if (.TRUE.) then
c           write following info.: time, sensor value, amplitude value
            write(105,'(EN16.4, :,10F16.6)')
     &        time(iTotalTime), rSensorRotVel, ampValueNew
          end if
c         ----------------------------------------------------------------------

        end if

      end if

      return
      end subroutine vuamp
c-------------------------------------EOF---------------------------------------
