c ------------------------------------BOF---------------------------------------

c     user amplitude subroutine
c
      subroutine vuamp(
c          passed in for information and state variables
     *     ampName, time, ampValueOld,  dt,  nSvars, svars, lFlagsInfo,
     *     nSensor, sensorValues, sensorNames, jSensorLookUpTable,
c          to be defined
     *     ampValueNew,
     *     lFlagsDefine,
     *     AmpDerivative, AmpSecDerivative, AmpIncIntegral)

      include 'vaba_param.inc'

c     svars - additional state variables, similar to (V)UEL
      dimension sensorValues(nSensor), svars(nSvars)
      character*80 sensorNames(nSensor)
      character*80 ampName

c     time indices
      parameter (iStepTime        = 1,
     *           iTotalTime       = 2,
     *           nTime            = 2)
c     flags passed in for information
      parameter (iInitialization   = 1,
     *           iRegularInc       = 2,
     *           nFlagsInfo        = 2)
c     optional flags to be defined
      parameter (iComputeDeriv     = 1,
     *           iComputeSecDeriv  = 2,
     *           iComputeInteg     = 3,
     *           iStopAnalysis     = 4,
     *           nFlagsDefine      = 4)
      dimension time(nTime), lFlagsInfo(nFlagsInfo),
     *          lFlagsDefine(nFlagsDefine)
      dimension jSensorLookUpTable(*)

      if (ampName .eq. 'SET_TORQUE_USER-AMP') then

c       read sensor value (rot. velocity) and assign to variable
        rSensorRotVel = vGetSensorValue('SENSOR_ROT_VEL',
     &                  jSensorLookUpTable, sensorValues)

c       is it initial increament ? ...
        if (lFlagsInfo(iInitialization) .eq. 1) then

          ampValueNew = 0.0d0

        else

c         ... check rot. velocity condition
          if (rSensorRotVel .lt. 10.0d0) then
c           ... if rot. vel. is lower then 10.0d0 set amp. to zero
            ampValueNew = 0.0d0
          else
c           ... if rot. vel. is higher or equal set amp. to torque
            ampValueNew = 500.0d0
          end if

        end if

      end if

      return
      end subroutine vuamp
c-------------------------------------EOF---------------------------------------
